'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _elementum = require('elementum');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = _elementum.StyleSheet.createClassMap({
  'self': 'ColumnColumn',
  'fill': 'ColumnColumn--Fill',
  'align=start': 'ColumnColumn--AlignStart',
  'align=center': 'ColumnColumn--AlignCenter',
  'align=end': 'ColumnColumn--AlignEnd',
  'justify=start': 'ColumnColumn--JustifyStart',
  'justify=center': 'ColumnColumn--JustifyCenter',
  'justify=end': 'ColumnColumn--JustifyEnd'
});

var Column = function Column(_ref) {
  var children = _ref.children;
  var fill = _ref.fill;
  var align = _ref.align;
  var justify = _ref.justify;
  return _react2.default.createElement(
    'div',
    { className: styles({ fill: fill, align: align, justify: justify }) },
    children
  );
};

Column.propTypes = {
  children: _react.PropTypes.oneOfType([_react.PropTypes.arrayOf(_react.PropTypes.element), _react.PropTypes.element]),
  fill: _react.PropTypes.bool,
  align: _react.PropTypes.oneOf(['start', 'center', 'end']),
  justify: _react.PropTypes.oneOf(['start', 'center', 'end'])
};

exports.default = Column;
//ELEMENTUM_STYLES_COMMENT
var ELEMENTUM_EXTRACTED_STYLES = {
  '.ColumnColumn': {
    display: 'flex',
    flexDirection: 'row',
    overflow: 'hidden',
    width: '100%'
  },
  '.ColumnColumn--Fill': {
    height: '100%'
  },
  '.ColumnColumn--AlignStart': {
    alignItems: 'flex-start'
  },
  '.ColumnColumn--AlignCenter': {
    alignItems: 'center'
  },
  '.ColumnColumn--AlignEnd': {
    alignItems: 'flex-end'
  },
  '.ColumnColumn--JustifyStart': {
    justifyContent: 'flex-start'
  },
  '.ColumnColumn--JustifyCenter': {
    justifyContent: 'center'
  },
  '.ColumnColumn--JustifyEnd': {
    justifyContent: 'flex-end'
  }
}; //ELEMENTUM_STYLES_COMMENT